;*************************************************************************************
;- <<< Operno nutzen >>>
; Autor: Josef Sniatecki
; Date: 18.05.2009
; Copyright: Josef Sniatecki 2009 (c)
; 
; Compiler info: debugger
;*************************************************************************************

; Dieser Quellcode zeigt, wie man die DLL von Operno verwendet.
; Zuserst mssen wir eine Quelldatei einbinden, die alle Befehle
; der DLL importiert und fr die Nutzung vorbereitet:
IncludeFile "Operno.pbi"

; Nun mssen wir Operno nur noch initialisieren:
InitOperno()



; Probieren wir mal gleich das Rechnen mit Operno aus:
Debug "  Aufgaben:"
Debug "1 + 1 + 1 ="
Debug OpernoExecuteI("1 + 1 + 1")
Debug "2 + 3 * 4 ="
Debug OpernoExecuteI("2 + 3 * 4")
Debug "(4 + 4) / 2 ="
Debug OpernoExecuteI("(4 + 4) / 2")

; Auch Floats lassen sich berechnen:
Debug "-------------------------------"
Debug "  Aufgaben mit Floats:"
Debug "10.0 / 4 ="
Debug OpernoExecuteF("10.0 / 4")
Debug "8.1 * 0.1 ="
Debug OpernoExecuteF("5.0 * 0.1")

; Natrlich sind auch Quad, Doubles und Strings mglich (...Execute- Q,D,S).



; Versuchen wir mal Objekte zu definieren und diese auch zu nutzen:
Debug "-------------------------------"
Debug "Variable definieren:"
Debug "x = 123"
X=OpernoCreateIVariable("x",123,*OpernoMainObject)
; "MainObject" ist ein Zeiger auf die Hauptgruppe.
; Dort sind alle globalen Objekte definiert. Die Variable
; "X" in PureBasic besitzt die ID des neuen Objekts.

Debug "-------------------------------"
Debug "Variable nutzen:"
Debug "x - 3 - 20 ="
Debug OpernoExecuteI("x - 3 - 20")

; Wir knnen auch die Variable ber Operno modifizeren und den
; Wert von x durch PureBasic ermitteln:
Debug "-------------------------------"
Debug "Variable modifizieren:"
Debug "x = 300 + 20 + 1"
OpernoExecute("x = 300 + 20 + 1")
Debug "x = "
Debug OpernoVariableI(X)



; Wir knnen auch Funktionen in Operno definieren:
Procedure.i MeinMessageRequester()
  Protected Titel.String,Text.String
  
  OpernoPopSValue(@Titel) ;Ersten Parameter ermitteln.
  OpernoPopSValue(@Text)  ;Zweiten Parameter ermitteln.
  
  MessageRequester(Titel\S,Text\S)
EndProcedure
; Diese Funktion stellen wir als Objekt bereit:
OpernoCreateFunction("messageRequester",@MeinMessageRequester(),*OpernoMainObject)
; Rufen wir die Funktion auf:
Debug "-------------------------------"
Debug "Eigene Funktion aufrufen:"
Debug "message requester("+Chr(34)+"Nachricht"+Chr(34)+", "+Chr(34)+"Hallo Welt!"+Chr(34)+")"
OpernoExecute("message requester("+Chr(34)+"Nachricht"+Chr(34)+", "+Chr(34)+"Hallo Welt!"+Chr(34)+")")

; Dies waren alle wichtigen Features der DLL. Operno verfgt
; ber noch mehr Funktionen, die jedoch nicht gut oder gar
; nicht dokumentiert sind. Im Beispiel "Squares.pb" kann man
; sehen, wie man Klassen definiert und Quellcodes aus der
; Festplatte ausfhrt.
; IDE Options = PureBasic 4.30 (Windows - x86)
; CursorPosition = 6
; Folding = -
; EnableXP