;*******************************************************
;- < Macros >
;
;*******************************************************

Macro _OpernoQ
"
EndMacro
Macro _OpernoImport(Function)
  Global Function.Function=*FunctionTable\L : *FunctionTable+4
EndMacro



;*******************************************************
;- < Constants >
;
;*******************************************************

; Object types:
Enumeration 1
  #OpernoObject_Group
  #OpernoObject_Function
  #OpernoObject_Variable
EndEnumeration
; Variable scopes:
#OpernoValue_Reference =%0001
#OpernoValue_Binary    =%0010
#OpernoValue_Searchable=%0100
#OpernoValue_Literal   =%1000



;*******************************************************
;- < Structures >
;
;*******************************************************

Structure OpernoObject
  Type.i
  Name.s
  StructureUnion
    *Group.OpernoGroup
    *Function.OpernoFunction
    *Variable.OpernoVariable
    *Memory
  EndStructureUnion
  *Super.OpernoObject
  *Item
  *Reference.OpernoObject
EndStructure
Structure OpernoGroup
  *ObjectQueue
  *ClassMethodArray
EndStructure
Structure OpernoFunction
  Type.i
  StructureUnion
    *Address
    *TokenQueue
  EndStructureUnion
  *Class.OpernoObject
EndStructure
Structure OpernoVariable
  *Value.OpernoValue
EndStructure
Structure OpernoValue
  *Class.Object
  StructureUnion
    *Memory
    *Integer.Integer
    *Float.Float
    *Quad.Quad
    *Double.Double
    *String.String
    *Queue
    *Object.OpernoObject
  EndStructureUnion
  Scope.i
  *Variable.OpernoObject
EndStructure



;*******************************************************
;- < Prototypes >
;
;*******************************************************

Prototype.i OpernoMainObject()
Prototype.i OpernoPreprozessorObject()
Prototype.i OpernoStandardLibrary()
Prototype.i OpernoIntegerClass()
Prototype.i OpernoFloatClass()
Prototype.i OpernoQuadClass()
Prototype.i OpernoDoubleClass()
Prototype.i OpernoBoolClass()
Prototype.i OpernoStringClass()
Prototype.i OpernoPointerClass()
Prototype.i OpernoObjectClass()

Prototype.i OpernoThis()
Prototype.i OpernoMemory()
Prototype.i OpernoTable()

Prototype.i OpernoError()
Prototype.i OpernoErrorMessage_()
Prototype.i OpernoRaiseError(Message.s)

Prototype.i OpernoValueClass(*Value)
Prototype.i OpernoValueMemory(*Value)
Prototype.i OpernoValueI(*Value)
Prototype.i OpernoValueF(*Value)
Prototype.i OpernoValueQ(*Value)
Prototype.i OpernoValueD(*Value)
Prototype.i OpernoValueB(*Value)
Prototype.i OpernoValueS_(*Value)
Prototype.i OpernoValueP(*Value)
Prototype.i OpernoValueScope(*Value)
Prototype.i OpernoSetValueScope(*Value,Scope.i)
Prototype.i OpernoAddValueScope(*Value,Scope.i)

Prototype.i OpernoSetValue(*Value,*SourceValue)
Prototype.i OpernoOperateValue(OperationID.i,*LHS,*RHS)
Prototype.i OpernoDuplicateValue(*Value)
Prototype.i OpernoPushDuplicatedValue(*Value)

Prototype.i OpernoExecute(Code.s)
Prototype.i OpernoExecuteI(Code.s)
Prototype.f OpernoExecuteF(Code.s)
Prototype.q OpernoExecuteQ(Code.s)
Prototype.d OpernoExecuteD(Code.s)
Prototype.i OpernoExecuteS_(Code.s)
Prototype.i OpernoExecuteCommands(Code.s)
Prototype.i OpernoExecuteFile(Name.s)

Prototype.i OpernoCreateIValue(Integer.i)
Prototype.i OpernoCreateFValue(Float.f)
Prototype.i OpernoCreateQValue(Queue.q)
Prototype.i OpernoCreateDValue(Double.d)
Prototype.i OpernoCreateBValue(State.i)
Prototype.i OpernoCreateSValue(String.s)
Prototype.i OpernoCreateQueueValue()
Prototype.i OpernoCreatePValue(*Object)
Prototype.i OpernoCreateReferenceValue(*Original)

Prototype.i OpernoPushIValue(Integer.i)
Prototype.i OpernoPushFValue(Float.f)
Prototype.i OpernoPushQValue(Quad.q)
Prototype.i OpernoPushDValue(Double.d)
Prototype.i OpernoPushBValue(State.i)
Prototype.i OpernoPushSValue(String.s)
Prototype.i OpernoPushQueueValue()
Prototype.i OpernoPushPValue(*Object)
Prototype.i OpernoPushReferenceValue(*Original)

Prototype.i OpernoArgumentCount()
Prototype.i OpernoPopValueAddress(*Result)
Prototype.i OpernoPopIValue(*Result)
Prototype.i OpernoPopFValue(*Result)
Prototype.i OpernoPopQValue(*Result)
Prototype.i OpernoPopDValue(*Result)
Prototype.i OpernoPopBValue(*Result)
Prototype.i OpernoPopSValue(*Result)
Prototype.i OpernoPopPValue(*Result)
Prototype.i OpernoPopVariable(*Result)

Prototype.i OpernoItemCount(*Value)
Prototype.i OpernoFirstItem(*Value)
Prototype.i OpernoLastItem(*Value)
Prototype.i OpernoNextItem(*Item)
Prototype.i OpernoPreviousItem(*Item)
Prototype.i OpernoItemValue(*Item)
Prototype.i OpernoClearQueue(*Value)
Prototype.i OpernoAppendItem(*Value,*NewMember)
Prototype.i OpernoPrependItem(*Value,*NewMember)
Prototype.i OpernoDeleteItem(*Value,*Item)

Prototype.i OpernoCreateGroup(Name.s,*Super=0)
Prototype.i OpernoChildCount(*Object)
Prototype.i OpernoFirstChild(*Object)
Prototype.i OpernoLastChild(*Object)

Prototype.i OpernoCreateVirtualTable(TableSize.i)
Prototype.i OpernoGetVirtualTable(*Object)

Prototype.i OpernoCreateFunction(Name.s,*Address,*Super=0)
Prototype.i OpernoCall(*Object,*ArgumentQueue=0,*This=0)
Prototype.i OpernoArguments1(*Value1)
Prototype.i OpernoArguments2(*Value1,*Value2)

Prototype.i OpernoCreateIVariable(Name.s,Integer.i,*Super=0)
Prototype.i OpernoCreateFVariable(Name.s,Float.f,*Super=0)
Prototype.i OpernoCreateQVariable(Name.s,Quad.q,*Super=0)
Prototype.i OpernoCreateDVariable(Name.s,Double.d,*Super=0)
Prototype.i OpernoCreateBVariable(Name.s,State.i,*Super=0)
Prototype.i OpernoCreateSVariable(Name.s,String.s,*Super=0)
Prototype.i OpernoCreatePVariable(Name.s,*Address,*Super=0)
Prototype.i OpernoCreateVVariable(Name.s,*Super=0)
Prototype.i OpernoVariableValue(*Object)
Prototype.i OpernoVariableMemory(*Object)
Prototype.i OpernoVariableI(*Object)
Prototype.f OpernoVariableF(*Object)
Prototype.q OpernoVariableQ(*Object)
Prototype.d OpernoVariableD(*Object)
Prototype.i OpernoVariableB(*Object)
Prototype.i OpernoVariableS_(*Object)
Prototype.i OpernoVariableP(*Object)
Prototype.i OpernoSetIVariable(*Object,Integer.i)
Prototype.i OpernoSetFVariable(*Object,Float.f)
Prototype.i OpernoSetQVariable(*Object,Quad.q)
Prototype.i OpernoSetDVariable(*Object,Double.d)
Prototype.i OpernoSetBVariable(*Object,State.i)
Prototype.i OpernoSetSVariable(*Object,String.s)
Prototype.i OpernoSetPVariable(*Object,*Address)

Prototype.i OpernoObjectName_(*Object)
Prototype.i OpernoRenameObject(*Object,Name.s)
Prototype.i OpernoNextObject(*Object)
Prototype.i OpernoPreviousObject(*Object)
Prototype.i OpernoFindObject(*Super,Name.s)
Prototype.i OpernoExtractObject(*Super,*Memory)
Prototype.i OpernoFreeObject(*Object)

Prototype.i OpernoOpenConsoleIDE()
Prototype.i OpernoOutput(Symbol.i,Text.s,Indent.i=0)
Prototype.i OpernoInput_(Symbol.i,Text.s,Indent.i)

Prototype.i OpernoSetStringCallback(*Address)



;*******************************************************
;- < Variables >
;
;*******************************************************

Global OpernoLibrary.i
Global *OpernoMainObject.OpernoObject
Global *OpernoPreprozessorObject.OpernoObject
Global *OpernoStandardLibrary.OpernoObject
Global *OpernoIntegerClass.OpernoObject
Global *OpernoFloatClass.OpernoObject
Global *OpernoQuadClass.OpernoObject
Global *OpernoDoubleClass.OpernoObject
Global *OpernoBoolClass.OpernoObject
Global *OpernoStringClass.OpernoObject
Global *OpernoPointerClass.OpernoObject
Global *OpernoObjectClass.OpernoObject



;*******************************************************
;- < Procedures >
;
;*******************************************************

Procedure.i OpernoStringCallback(String.s,*Result.String)
  ; Strings aus dem Client werden nicht innerhalb der DLL modifiziert, da
  ; der Heap nur innerhalb des Clients aktuallisiert werden kann.
  *Result\S=String
EndProcedure
Procedure.i InitOperno(DLLName.s="Operno.dll")
  Protected *FunctionTable.Long
  
  OpernoLibrary=OpenLibrary(#PB_Any,DLLName)
  If OpernoLibrary
    *FunctionTable=CallFunction(OpernoLibrary,"OpernoFunctionTable")
    
    _OpernoImport(OpernoMainObject)
    _OpernoImport(OpernoPreprozessorObject)
    _OpernoImport(OpernoStandardLibrary)
    _OpernoImport(OpernoIntegerClass)
    _OpernoImport(OpernoFloatClass)
    _OpernoImport(OpernoQuadClass)
    _OpernoImport(OpernoDoubleClass)
    _OpernoImport(OpernoBoolClass)
    _OpernoImport(OpernoStringClass)
    _OpernoImport(OpernoPointerClass)
    _OpernoImport(OpernoObjectClass)
    
    _OpernoImport(OpernoThis)
    _OpernoImport(OpernoMemory)
    _OpernoImport(OpernoTable)
    
    _OpernoImport(OpernoError)
    _OpernoImport(OpernoErrorMessage_)
    _OpernoImport(OpernoRaiseError)
    
    _OpernoImport(OpernoExecute)
    _OpernoImport(OpernoExecuteI)
    _OpernoImport(OpernoExecuteF)
    _OpernoImport(OpernoExecuteQ)
    _OpernoImport(OpernoExecuteD)
    _OpernoImport(OpernoExecuteS_)
    _OpernoImport(OpernoExecuteCommands)
    _OpernoImport(OpernoExecuteFile)
    
    _OpernoImport(OpernoValueClass)
    _OpernoImport(OpernoValueMemory)
    _OpernoImport(OpernoValueI)
    _OpernoImport(OpernoValueF)
    _OpernoImport(OpernoValueQ)
    _OpernoImport(OpernoValueD)
    _OpernoImport(OpernoValueB)
    _OpernoImport(OpernoValueS_)
    _OpernoImport(OpernoValueP)
    _OpernoImport(OpernoValueScope)
    _OpernoImport(OpernoSetValueScope)
    _OpernoImport(OpernoAddValueScope)
    
    _OpernoImport(OpernoSetValue)
    _OpernoImport(OpernoOperateValue)
    _OpernoImport(OpernoDuplicateValue)
    _OpernoImport(OpernoPushDuplicatedValue)
    
    _OpernoImport(OpernoCreateIValue)
    _OpernoImport(OpernoCreateFValue)
    _OpernoImport(OpernoCreateQValue)
    _OpernoImport(OpernoCreateDValue)
    _OpernoImport(OpernoCreateBValue)
    _OpernoImport(OpernoCreateSValue)
    _OpernoImport(OpernoCreateQueueValue)
    _OpernoImport(OpernoCreatePValue)
    _OpernoImport(OpernoCreateReferenceValue)
    
    _OpernoImport(OpernoPushIValue)
    _OpernoImport(OpernoPushFValue)
    _OpernoImport(OpernoPushQValue)
    _OpernoImport(OpernoPushDValue)
    _OpernoImport(OpernoPushBValue)
    _OpernoImport(OpernoPushSValue)
    _OpernoImport(OpernoPushQueueValue)
    _OpernoImport(OpernoPushPValue)
    _OpernoImport(OpernoPushReferenceValue)
    
    _OpernoImport(OpernoArgumentCount)
    _OpernoImport(OpernoPopValueAddress)
    _OpernoImport(OpernoPopIValue)
    _OpernoImport(OpernoPopFValue)
    _OpernoImport(OpernoPopQValue)
    _OpernoImport(OpernoPopDValue)
    _OpernoImport(OpernoPopBValue)
    _OpernoImport(OpernoPopSValue)
    _OpernoImport(OpernoPopPValue)
    _OpernoImport(OpernoPopVariable)
    
    _OpernoImport(OpernoItemCount)
    _OpernoImport(OpernoFirstItem)
    _OpernoImport(OpernoLastItem)
    _OpernoImport(OpernoNextItem)
    _OpernoImport(OpernoPreviousItem)
    _OpernoImport(OpernoItemValue)
    _OpernoImport(OpernoClearQueue)
    _OpernoImport(OpernoAppendItem)
    _OpernoImport(OpernoPrependItem)
    _OpernoImport(OpernoDeleteItem)
    
    _OpernoImport(OpernoCreateGroup)
    _OpernoImport(OpernoChildCount)
    _OpernoImport(OpernoFirstChild)
    _OpernoImport(OpernoLastChild)
    
    _OpernoImport(OpernoCreateVirtualTable)
    _OpernoImport(OpernoGetVirtualTable)
    
    _OpernoImport(OpernoCreateFunction)
    _OpernoImport(OpernoCall)
    _OpernoImport(OpernoArguments1)
    _OpernoImport(OpernoArguments2)
    
    _OpernoImport(OpernoCreateIVariable)
    _OpernoImport(OpernoCreateFVariable)
    _OpernoImport(OpernoCreateQVariable)
    _OpernoImport(OpernoCreateDVariable)
    _OpernoImport(OpernoCreateBVariable)
    _OpernoImport(OpernoCreateSVariable)
    _OpernoImport(OpernoCreatePVariable)
    _OpernoImport(OpernoCreateVVariable)
    _OpernoImport(OpernoVariableValue)
    _OpernoImport(OpernoVariableMemory)
    _OpernoImport(OpernoVariableI)
    _OpernoImport(OpernoVariableF)
    _OpernoImport(OpernoVariableQ)
    _OpernoImport(OpernoVariableD)
    _OpernoImport(OpernoVariableB)
    _OpernoImport(OpernoVariableS_)
    _OpernoImport(OpernoVariableP)
    _OpernoImport(OpernoSetIVariable)
    _OpernoImport(OpernoSetFVariable)
    _OpernoImport(OpernoSetQVariable)
    _OpernoImport(OpernoSetDVariable)
    _OpernoImport(OpernoSetBVariable)
    _OpernoImport(OpernoSetSVariable)
    _OpernoImport(OpernoSetPVariable)
    
    _OpernoImport(OpernoObjectName_)
    _OpernoImport(OpernoRenameObject)
    _OpernoImport(OpernoNextObject)
    _OpernoImport(OpernoPreviousObject)
    _OpernoImport(OpernoFindObject)
    _OpernoImport(OpernoExtractObject)
    _OpernoImport(OpernoFreeObject)
    
    _OpernoImport(OpernoOpenConsoleIDE)
    _OpernoImport(OpernoOutput)
    _OpernoImport(OpernoInput_)
    
    _OpernoImport(OpernoSetStringCallback)
    
    ; Initialize important variables of Operno:
    *OpernoMainObject=OpernoMainObject()
    *OpernoPreprozessorObject=OpernoPreprozessorObject()
    *OpernoStandardLibrary=OpernoStandardLibrary()
    *OpernoIntegerClass=OpernoIntegerClass()
    *OpernoFloatClass=OpernoFloatClass()
    *OpernoQuadClass=OpernoQuadClass()
    *OpernoDoubleClass=OpernoDoubleClass()
    *OpernoBoolClass=OpernoBoolClass()
    *OpernoStringClass=OpernoStringClass()
    *OpernoPointerClass=OpernoPointerClass()
    *OpernoObjectClass=OpernoObjectClass()
    
    ; Send the address of the "OpernoSetStringCallback":
    OpernoSetStringCallback(@OpernoStringCallback())
    ProcedureReturn OpernoLibrary
  EndIf
  ProcedureReturn #False
EndProcedure
Procedure.i ReloadOperno()
  CloseLibrary(OpernoLibrary)
  ProcedureReturn InitOperno()
EndProcedure
Procedure.i CloseOperno()
  CloseLibrary(OpernoLibrary)
EndProcedure

; Special functions for results as a string:
Procedure.s OpernoErrorMessage()
  ProcedureReturn PeekS(OpernoErrorMessage_())
EndProcedure
Procedure.s OpernoExecuteS(Code.s)
  ProcedureReturn PeekS(OpernoExecuteS_(Code))
EndProcedure
Procedure.s OpernoValueS(*Value)
  ProcedureReturn PeekS(OpernoValueS_(*Value))
EndProcedure
Procedure.s OpernoObjectName(*Object)
  ProcedureReturn PeekS(OpernoObjectName_(*Object))
EndProcedure
Procedure.s OpernoInput(Symbol.i=0,Text.s="",Indent.i=0)
  ProcedureReturn PeekS(OpernoInput_(Symbol,Text,Indent))
EndProcedure

; IDE Options = PureBasic 4.31 Beta 1 (Windows - x86)
; CursorPosition = 376
; FirstLine = 358
; Folding = ---
; EnableXP